       * PRISMOD MODEL - dopris0_master.do *
* Libor Dusek, Jan Vavra, Paolo Buonanno
** more info in dopris0_readme.do

* MAKE ALTERNATIVE SIMPLE ALTERNATIVE SCENARIO *
** makes simple alternative scenarios by fixing paras in average values

* Variables, that can used:
	* 1. Police variables
		** c1 - number of tr. rizeni started
		** z1 - av. length between start of tr. rizeni and ukoncenim tr. rizeni
		** p1 - prob. of tr. stihani
	* 2. Prosecutor variables
		** z2 - duration from obtaining the case from police to charge
		** p2 - propability of charge
	* 3. Court variables
		** z3 - duration from charge to sentence
		** p3 - propability of conviction
			* p4 - prop of prison sentence
			* p_a1 - prop of parole
			* p_a2 - prop of alternative sentence
			** s_hs, s_ls - sentences of regular ls/hs prisoners from courts
			** p4_hs - prob. of sentencing to HS prison
		** la1, la2, la3 - lenght of parole/com. service/prison parole trial period
	* 4. Prison variables and other
		** lc - custody length
		** p5 - prob. of nonentered sentence
		** pe_o - prob. of release to next sentence or release for other reasons
		** pe_hsls - prob. of transfer from HS prison to LS prison
		** p_z4 - fraction of cohort that entered in 1st quarter
		** s_a1, s_a2, s_a3 - sentences of parole/cs violators, pa3 - prob. of prison parole from stock of prisoners
		** vr_a1, vr_a2, vr_a3 - simulated rate of entry from population at risk stocks to prisons
	* Here is the list of all parameters to copy if needed:
* local allpars = "c1 p1 z1 z2 p2 z3 p3 p4 p_a1 p_a2 s_hs s_ls p4_hs lc la1 la2 la3 p5 pe_a3 pe_o pe_hsls p_z4 s_a1 s_a2 s_a3 vr_a1 vr_a2 vr_a3"
clear
* 1. Select name of changed model (name of new folder and prefix of models files), not base!!
local p ="count_vras2005"
		
* 2. Select paramethers to be changed, you can use multiple pars like "c2 p2 p3" or just one, or "ALL" for all paramethers
local fixpar = "vr_a1 vr_a2 vr_a3"

* 3. Quarters to get values of fixed paramethers, you can use multiple dates for multiple pars, if only one date is present, it works for all defined variables, 2010q4 -  average of 2010q1-2010q4
local fixyq   = "2005q4"

* 4. Quarters to apply fixed parameters from,  you can use multiple dates for multiple pars, if only one date is present, it works for all defined variables
local fixapp   = "2006q1"

* 5. Form of change, number is hardcoded, "a" mean average of previous year, if only "a" is present, it works for all defined variables in all quarters
local fixform = "a"

* 6. Amnesty
** use hardcoded amnesty from 2013? yes or no?
** no - make all amnesty variables zero
local amnesty_modelling = "1"

* compare with scenario, default is base
local tocompare = "base"

/*************************************************************************
Examples:
1. all para on 2009 level
local p ="all2009"
local fixpar = "ALL"
local fixyq   = "2009q4"
local fixapp   = "2010q1"
local fixform = "a"
2. c2 on 2009 level from 2015q1
local p ="c2009"
local fixpar = "c2"
local fixyq   = "2009q4"
local fixapp   = "2015q1"
local fixform = "a"
2. court variables on 2009 level from 2015q1
local p ="court2009"
local fixpar = "z3 p3 p4 p_a1 p_a2 s_hs s_ls p4_hs"
local fixyq   = "2009q4"
local fixapp   = "2015q1"
local fixform = "a"				
*************************************************************************/

set more off
global pcent "100" 
* 5. Make alternative paramether files, create new "g" file in new folder
quietly {
	global pcent "100" 	
	if "`p'" == "base" {
	noisily display "NAME OF SCENARIO CANT BE "BASE" "
	exit(0)
	}	
	* erase old folder !! need to use WINDOWS SHELL!!! to remove full directory
	!rmdir simulations_$pcent\\`p'  /s /q
	* make folders for the model
	capture mkdir simulations_$pcent/`p'/
	capture mkdir simulations_$pcent/`p'/diag/

	** save new para file in new folder 
	use simulations_$pcent/base/base_paramavg_$pcent
	save simulations_$pcent/`p'/`p'_paramavg_$pcent, replace
	sort oca q

	** generate local as count of words in local "vectors"
	local n1 : word count `fixpar'
	local n2 : word count `fixyq'
	local n3 : word count `fixform'
	local n4 : word count `fixapp'
	
	** perform logical conditions for consistency
	if `n1'==1 & `n2'==1 & `n3'==1 & `n4'==1 | `n1'!=1 | ( "`fixpar'"=="ALL"  & `n2'==1 & `n3'==1) {
	display "OK"
	}
	else {
	noisily display "WRONG NUMBER OF INPUTS"
	exit(0)
	}
	** other cases are possible
	
	** if all variables are fixed
	if "`fixpar'"=="ALL"  & `n2'==1 & `n3'==1  & `n4'==1 {
		ds oca q amr_a1 amr_a2 amr_a3 amv_rp amv_a1 amv_a2 amv_a3 p12 p23 p45, not
		foreach var in `r(varlist)' {
			forvalues ocas = 1 (1) 9 {
			sum `var' if oca==`ocas' & q <= tq(`fixyq') & q >= tq(`fixyq')-3
			local x = r(mean)
			replace `var'= `x' if oca==`ocas' & q>=tq(`fixapp') 
			}
		}
	* end if
	}
	else {
	* for every paramether (word) in fixpar
	forvalues i = 1/`n1'{
		* make another local as is name
		local fixpara : word `i' of `fixpar'
		* if there is only one source and apply quarter
		if `n2'==1 & `n4'==1 {
		local fixyqa : word 1 of `fixyq'
		local fixapply : word 1 of `fixapp'
		}
		* if there is one source and multiple apply
		if `n2'==1 & `n4'>1 {
		local fixyqa : word 1 of `fixyq'
		local fixapply : word `i' of `fixapp'
		}
		* if there is multiple source and one apply
		if `n2'>1 & `n4'==1 {
		local fixyqa : word `i' of `fixyq'
		local fixapply : word 1 of `fixapp'
		}
		* if there is multiple sources and multiple apply
		if `n2'>1 & `n4'>1 {
		local fixyqa : word `i' of `fixyq'
		local fixapply : word `i' of `fixapp'
		}		
		* for every oca	
		forvalues ocas = 1 (1) 9 {
			if `n3'==1 {
			* if there is only one value to fix
				local fixforma : word 1 of `fixform'
				}
			* if there are more values to fix
			if `n3'> 1 {
				local fixforma : word `i' of `fixform'
				}
			* if fix is on average
			if "`fixforma'"=="a" {
				sum `fixpara' if oca==`ocas' & q <= tq(`fixyqa') & q >= tq(`fixyqa')-3
				local x = r(mean)
				replace `fixpara' = `x' if oca==`ocas' & q>tq(`fixapply') & `x'~=.
				}
			* if fix is hardcoded number
			else {
				replace `fixpara' = `fixforma'*`fixpara' if oca==`ocas' & q>tq(`fixapply') 
				}
			}			
		}
	* end else	
	}	
	
	
	
	if `amnesty_modelling'!=1 {
	ds amr_a1 amr_a2 amr_a3 amv_rp amv_a1 amv_a2 amv_a3
		foreach var in `r(varlist)' {
		replace `var'=0
		}
	}
	save simulations_$pcent/`p'/`p'_paramavg_$pcent, replace

noisily display "Setup of `p'  scenario pars complete!"
* end quiet

}

* 6. Run the model witn new pars
	quietly do dopris3_modelavg
	pminflowsimul `p'
	
* 7. make plots for the model and compare it with another model
	do dopris4_descriptive
	paraplot `p'
	modelfit `p'
	modelcompare `p' `tocompare'
